import _extends from "@babel/runtime/helpers/extends";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import { getLogger } from '@gant-lowcode/lowcode-utils';
import baseRendererFactory from './base';
import { create as createDataSourceEngine } from '@alilc/lowcode-datasource-engine/interpret';
import adapter from '../adapter';
import { generateComponentCode, getAgnosticComponent, getI18n } from '../utils';
var logger = getLogger({
  level: 'warn',
  bizName: 'renderer-core:page'
});
export default function pageRendererFactory() {
  var BaseRenderer = baseRendererFactory();
  var PageRenderer = /*#__PURE__*/function (_BaseRenderer) {
    function PageRenderer() {
      var _this;
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      _this = _BaseRenderer.call.apply(_BaseRenderer, [this].concat(args)) || this;
      _this.__namespace = 'page';
      return _this;
    }
    _inheritsLoose(PageRenderer, _BaseRenderer);
    var _proto = PageRenderer.prototype;
    _proto.__afterInit = function __afterInit(props) {
      this.__generateCtx({
        page: this
      });
    };
    _proto.render = function render() {
      var _this$props = this.props,
        __schema = _this$props.__schema,
        __components = _this$props.__components;
      if (this.__checkSchema(__schema)) {
        return '页面schema结构异常！';
      }
      this.__debug(PageRenderer.displayName + " render - " + __schema.fileName);
      this.__generateCtx({
        page: this
      });
      this.__render();
      var Page = __components.Page;
      console.log('---Page', __components, Page);
      if (Page) {
        return this.__renderComp(Page, {
          pageContext: this
        });
      }
      return this.__renderContent(this.__renderContextProvider({
        pageContext: this
      }));
    };
    return PageRenderer;
  }(BaseRenderer);
  PageRenderer.displayName = 'PageRenderer';
  return function FunctionPageRenderer(props) {
    var _props$__appHelper2, _props$__appHelper3, _props$__appHelper4;
    var defaultDataSource = {
      list: []
    };
    console.log('FunctionPageRenderer--props', props);
    var dataSource = props.__schema.dataSource || defaultDataSource;
    var _adapter$hooks$useSta = adapter.hooks.useState(),
      state = _adapter$hooks$useSta[0],
      setState = _adapter$hooks$useSta[1];
    var dataSourceMap = adapter.hooks.useMemo(function () {
      var _props$__appHelper;
      var useDataSourceEngine = !!((_props$__appHelper = props.__appHelper) !== null && _props$__appHelper !== void 0 && _props$__appHelper.requestHandlersMap);
      if (useDataSourceEngine) {
        var _createDataSourceEngi = createDataSourceEngine(dataSource, {
            setState: setState
          }, props.__appHelper.requestHandlersMap ? {
            requestHandlersMap: props.__appHelper.requestHandlersMap
          } : undefined),
          _dataSourceMap = _createDataSourceEngi.dataSourceMap,
          reloadDataSource = _createDataSourceEngi.reloadDataSource;
        reloadDataSource();
        return _dataSourceMap;
      }
      return {};
    }, []);
    var i18n = function i18n(key, values) {
      if (values === void 0) {
        values = {};
      }
      var locale = props.locale,
        messages = props.messages;
      return getI18n(key, values, locale, messages);
    };
    var getLocale = function getLocale() {
      return props.locale;
    };
    var setLocale = function setLocale(loc) {
      var _utils, _utils$i18n;
      var setLocaleFn = (_utils = utils) === null || _utils === void 0 ? void 0 : (_utils$i18n = _utils.i18n) === null || _utils$i18n === void 0 ? void 0 : _utils$i18n.setLocale;
      if (!setLocaleFn || typeof setLocaleFn !== 'function') {
        logger.warn('initI18nAPIs Failed, i18n only works when appHelper.utils.i18n.setLocale() exists');
        return undefined;
      }
      return setLocaleFn(loc);
    };
    var code = generateComponentCode(props.__schema);
    // console.log('---code', code);
    var CompiledComponent = getAgnosticComponent(code, _extends({}, state, {
      dataSourceMap: dataSourceMap
    }, adapter.hooks, {
      props: props,
      i18n: i18n,
      setLocale: setLocale,
      getLocale: getLocale
    }, props.__appHelper, (_props$__appHelper2 = props.__appHelper) === null || _props$__appHelper2 === void 0 ? void 0 : _props$__appHelper2.system, (_props$__appHelper3 = props.__appHelper) === null || _props$__appHelper3 === void 0 ? void 0 : _props$__appHelper3.hooks, {
      utils: (_props$__appHelper4 = props.__appHelper) === null || _props$__appHelper4 === void 0 ? void 0 : _props$__appHelper4.utils
    }));
    return adapter.runtime.createElement(CompiledComponent, {}, function (__runtimeScope__) {
      return adapter.runtime.createElement(PageRenderer, _extends({
        __runtimeScope__: __runtimeScope__
      }, props));
    });
  };
}